;******************** (C) COPYRIGHT 2011 STMicroelectronics ********************
;* File Name          : startup_stm32f10x_md.s
;* Author             : MCD Application Team
;* Version            : V3.5.0
;* Date               : 11-March-2011
;* Description        : STM32F10x Medium Density Devices vector table for 
;*                      EWARM toolchain.
;*                      This module performs:
;*                      - Set the initial SP
;*                      - Configure the clock system
;*                      - Set the initial PC == __iar_program_start,
;*                      - Set the vector table entries with the exceptions ISR 
;*                        address.
;*                      After Reset the Cortex-M3 processor is in Thread mode,
;*                      priority is Privileged, and the Stack is set to Main.
;********************************************************************************
;* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
;* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
;* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
;* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
;* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
;* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
;*******************************************************************************
;
;
; The modules in this file are included in the libraries, and may be replaced
; by any user-defined modules that define the PUBLIC symbol _program_start or
; a user defined start symbol.
; To override the cstartup defined in the library, simply add your modified
; version to the workbench project.
;
; The vector table is normally located at address 0.
; When debugging in RAM, it can be located in RAM, aligned to at least 2^6.
; The name "__vector_table" has special meaning for C-SPY:
; it is where the SP start value is found, and the NVIC vector
; table register (VTOR) is initialized to this address if != 0.
;
; Cortex-M version
;

        MODULE  ?cstartup

        ;; Forward declaration of sections.
        SECTION CSTACK:DATA:NOROOT(3)

        SECTION .intvec:CODE:NOROOT(2)

        EXTERN  __iar_program_start
        EXTERN  SystemInit        
        PUBLIC  __vector_table

        DATA
__vector_table
        DCD     sfe(CSTACK)
        DCD     Reset_Handler             ; Reset Handler
        DCD     Empty_Handler               ; NMI Handler
        DCD     Empty_Handler         ; Hard Fault Handler
        DCD     Empty_Handler         ; MPU Fault Handler
        DCD     Empty_Handler          ; Bus Fault Handler
        DCD     Empty_Handler        ; Usage Fault Handler
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     Empty_Handler               ; SVCall Handler
        DCD     Empty_Handler          ; Debug Monitor Handler
        DCD     0                         ; Reserved
        DCD     Empty_Handler            ; PendSV Handler
        DCD     Empty_Handler           ; SysTick Handler

         ; External Interrupts
        DCD     Empty_Handler           ; Window Watchdog
        DCD     Empty_Handler            ; PVD through EXTI Line detect
        DCD     Empty_Handler         ; Tamper
        DCD     Empty_Handler            ; RTC
        DCD     Empty_Handler          ; Flash
        DCD     Empty_Handler            ; RCC
        DCD     Empty_Handler          ; EXTI Line 0
        DCD     Empty_Handler          ; EXTI Line 1
        DCD     Empty_Handler          ; EXTI Line 2
        DCD     Empty_Handler          ; EXTI Line 3
        DCD     Empty_Handler          ; EXTI Line 4
        DCD     Empty_Handler  ; DMA1 Channel 1
        DCD     Empty_Handler  ; DMA1 Channel 2
        DCD     Empty_Handler  ; DMA1 Channel 3
        DCD     Empty_Handler  ; DMA1 Channel 4
        DCD     Empty_Handler  ; DMA1 Channel 5
        DCD     Empty_Handler  ; DMA1 Channel 6
        DCD     Empty_Handler  ; DMA1 Channel 7
        DCD     Empty_Handler         ; ADC1 & ADC2
        DCD     Empty_Handler  ; USB High Priority or CAN1 TX
        DCD     Empty_Handler ; USB Low  Priority or CAN1 RX0
        DCD     Empty_Handler       ; CAN1 RX1
        DCD     Empty_Handler       ; CAN1 SCE
        DCD     Empty_Handler        ; EXTI Line 9..5
        DCD     Empty_Handler       ; TIM1 Break
        DCD     Empty_Handler        ; TIM1 Update
        DCD     Empty_Handler   ; TIM1 Trigger and Commutation
        DCD     Empty_Handler        ; TIM1 Capture Compare
        DCD     Empty_Handler           ; TIM2
        DCD     Empty_Handler           ; TIM3
        DCD     Empty_Handler           ; TIM4
        DCD     Empty_Handler        ; I2C1 Event
        DCD     Empty_Handler        ; I2C1 Error
        DCD     Empty_Handler        ; I2C2 Event
        DCD     Empty_Handler        ; I2C2 Error
        DCD     Empty_Handler           ; SPI1
        DCD     Empty_Handler           ; SPI2
        DCD     Empty_Handler         ; USART1
        DCD     Empty_Handler         ; USART2
        DCD     Empty_Handler         ; USART3
        DCD     Empty_Handler      ; EXTI Line 15..10
        DCD     Empty_Handler       ; RTC Alarm through EXTI Line
        DCD     Empty_Handler      ; USB Wakeup from suspend

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Default interrupt handlers.
;;
        THUMB
        
        PUBWEAK Reset_Handler
        SECTION .text:CODE:REORDER:NOROOT(2)
Reset_Handler
        LDR     R0, =SystemInit
        BLX     R0
        LDR     R0, =__iar_program_start
        BX      R0

        PUBLIC Empty_Handler
        SECTION .text:CODE:REORDER:NOROOT(2)
Empty_Handler
        LDR     R0, =Empty_Handler
        BX      R0
        
        END
/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
